      subroutine tinfo(m,n,dim,ldptab,ptab,ncov1,npoly,t,
     * wptr,info)
c
      integer m,n,dim,npoly,wptr(dim),info, ldptab
      integer ptab(ldptab,dim)
c
c Purpose: create t matrix and append s1 to it.
c
c On Entry:
c   m			order of the derivatives in the penalty
c   n			number of rows in des
c   dim			number of columns in des
c   ncov1		number of columns in s1
c On Exit:
c   npoly		dimension of polynomial part of spline
c   info 		error indication
c   			   0 : successful completion
c		 	   1 : error in creation of t
c Work Arrays:
c   wptr(dim)		integer work vector
c
c Subprograms Called Directly:
c	Blas  - dcopy
c	Other - mkpoly
c
c $Header: /usr/local/cvsroot/funfits22/src/Tpsreg/tinfo.f,v 1.1.1.1 1999/06/11 16:36:35 agebhard Exp $
c
      integer i,j,k,tt,nt,bptr,eptr
      integer mkpoly

c
      info = 0
      npoly = mkpoly(m,dim)
      call dset(n,1.0d0,t(1,1),1)
      nt = 1
          do 10 j=1,dim
             nt = j + 1
             wptr(j) = nt
          do 11 jj=1, ldptab
              ptab(jj,j)=0
   11     continue
   10     continue

c fill in powers of linear part. 

          do 15 jj= 1, dim
                ptab(jj+1,jj)=1
 15              continue
c
c     get cross products of x's in null space for m>2
c
c     WARNING: do NOT change next do loop unless you fully understand:
c              This first gets x1*x1, x1*x2, x1*x3, then
c              x2*x2, x2*x3, and finally x3*x3 for dim=3,n=3
c              wptr(1) is always at the beginning of the current
c	       level of cross products, hence the end of the
c	       previous level which is used for the next.
c	       wptr(j) is at the start of xj * (previous level)
c
          if( nt.gt.ldptab) then 
              info=-1
          return
          endif
          do 50 k=2,m-1
             do 40 j=1,dim
                bptr = wptr(j)
                wptr(j) = nt + 1
                eptr = wptr(1) - 1
                do 30 tt=bptr,eptr
                   nt = nt + 1
                     ptab(nt,j)= ptab(tt,j) + 1
C                   do 20 i=1,n
C                      t(i,nt) = des(i,j) * t(i,tt)
C                       
C   20              continue
   30           continue
   40        continue
   50     continue
      end









